diff --git a/build.gradle.kts b/build.gradle.kts
index 561df0df9..93a4bf8c8 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -145,10 +145,6 @@ dependencies {
 
     implementation("com.github.JnCrMx:discord-game-sdk4j:v0.5.5")?.let { clientInclude(it) }
 
-    runtimeOnly("net.java.jinput:jinput-platform:2.0.5")
-    implementation("net.java.jinput:jinput:2.0.5")
-    implementation("net.java.jutils:jutils:1.0.0")
-
     implementation("objects:client:43db9b498cb67058d2e12d394e6507722e71bb45") // Minecraft client jar
 
     val log4jVersion = "2.20.0"
diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index f41aabcf1..5f4904060 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -158,7 +158,6 @@ options.lightmapStyle.disabled=Disabled
 options.customLightmap=Custom Lightmap
 options.old=Old Menu
 options.lockCamera=Lock Camera
-options.disableJInput=Disable JInput
 options.disableCrashHandler=Disable Crash Handler
 options.disableResize=Disable Resize
 options.startInFullscreen=Start In Fullscreen
diff --git a/src/common/resources/lang/en_US/strings.lang b/src/common/resources/lang/en_US/strings.lang
index 269e2d9bd..a72990d37 100644
--- a/src/common/resources/lang/en_US/strings.lang
+++ b/src/common/resources/lang/en_US/strings.lang
@@ -1,5 +1,5 @@
 dimension.overworld.name=the Overworld
-dimension.hell.name=the Nether
+dimension.nether.name=the Nether
 dimension.paradise.name=Paradise
 
 season.overworld.spring.name=Spring
diff --git a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index 5f3b15b42..2b74f56c4 100644
--- a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -1,7 +1,7 @@
 package net.betterthanadventure.utils;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
+import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.data.registry.Registries;
@@ -512,12 +512,12 @@ public class BiomeFinder implements MinecraftAccessor {
 				int z = offsetZ + j * renderScale;
 
 				Biome biome = null;
-				if (world != null && world.getChunkProvider() instanceof ChunkProviderStatic){
+				if (world != null && world.getChunkProvider() instanceof ChunkProviderDynamic){
                     try {
 						if (lastChunkX != Math.floorDiv(x, Chunk.CHUNK_SIZE_X) || lastChunkZ != Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)){
 							lastChunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
 							lastChunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
-							chunk = ((ChunkProviderStatic) world.getChunkProvider()).getChunkLoader().loadChunk(world, lastChunkX, lastChunkZ);
+							chunk = ((ChunkProviderDynamic) world.getChunkProvider()).getChunkLoader().loadChunk(world, lastChunkX, lastChunkZ);
 						}
 						if (chunk != null){
 							biome = chunk.getBlockBiome(x & (Chunk.CHUNK_SIZE_X - 1), posY, z & (Chunk.CHUNK_SIZE_Z - 1));
@@ -642,7 +642,7 @@ public class BiomeFinder implements MinecraftAccessor {
 
 	@Override
 	public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
-		return new ChunkProviderStatic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+		return new ChunkProviderDynamic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 20c495e07..30270e34f 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -19,6 +19,7 @@ import java.util.Random;
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
 
+import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import org.lwjgl.LWJGLException;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -67,7 +68,6 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerController;
-import net.minecraft.client.render.ChunkRenderer;
 import net.minecraft.client.render.EffectRenderer;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.FallbackRenderer;
@@ -89,6 +89,10 @@ import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
+import net.minecraft.client.render.terrain.ChunkRenderer;
+import net.minecraft.client.render.terrain.TerrainRenderer;
+import net.minecraft.client.render.terrain.TerrainRendererLegacy;
+import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePackList;
@@ -99,7 +103,6 @@ import net.minecraft.client.util.debug.Debug;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.util.helper.ScreenshotHelper;
 import net.minecraft.client.util.helper.Textures;
-import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.MinecraftError;
@@ -238,6 +241,7 @@ public class Minecraft
      */
     private boolean gameStarted = false;
     private int mojrand = new Random(System.currentTimeMillis()).nextInt(200);
+    public TerrainRenderer terrainRenderer;
     
     public Minecraft(GameWindow gameWindow)
     {
@@ -417,6 +421,19 @@ public class Minecraft
 		
         OpenGLHelper.testCapabilities(this);
         
+        if(gameSettings.enableMultiDrawRendering.value) {
+            if(OpenGLHelper.gl20) {
+            	System.out.println("Using MultiDraw terrain renderer");
+            	terrainRenderer = new TerrainRendererMultiDraw(this);
+            }else {
+            	System.out.println("MultiDraw not supported, using legacy terrain renderer");
+            	terrainRenderer = new TerrainRendererLegacy(this);
+            }	
+        }else {
+        	System.out.println("MultiDraw disabled, using legacy terrain renderer");
+        	terrainRenderer = new TerrainRendererLegacy(this);
+        }
+        
         if(Shaders.enableShaders) {
             setRenderer(new ShadersRenderer(this));
         }else {
@@ -452,6 +469,7 @@ public class Minecraft
             System.err.println("Input init error!");
             e.printStackTrace();
         }
+        mouseInput.setRawInput(gameSettings.rawMouseInput.value);
         System.out.println("Input done!");
         
         System.out.println("Setting up OpenGL values...");
@@ -598,7 +616,7 @@ public class Minecraft
     private void loadScreen() throws LWJGLException
     {
         System.out.println("Drawing Loading Screen...");
-        glClear(16640);
+        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
         glMatrixMode(GL11.GL_PROJECTION);
         glLoadIdentity();
         glOrtho(0.0D, resolution.scaledWidthExact, resolution.scaledHeightExact, 0.0D, 1000D, 3000D);
@@ -615,7 +633,7 @@ public class Minecraft
         if(mojrand == 0)
             renderEngine.loadTexture("/assets/minecraft/textures/gui/title/majonk.png").bind();
         else
-            renderEngine.loadTexture("/title/mojang.png").bind();
+            renderEngine.loadTexture("/assets/minecraft/textures/gui/title/mojang.png").bind();
         
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xffffff);
@@ -635,7 +653,7 @@ public class Minecraft
         glDisable(GL11.GL_LIGHTING);
         glDisable(GL11.GL_FOG);
         glEnable(GL11.GL_ALPHA_TEST);
-        glAlphaFunc(516, 0.1F);
+        glAlphaFunc(GL_GREATER,0.1F);
         gameWindow.update();
     }
 
@@ -670,7 +688,7 @@ public class Minecraft
     @Override
     public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader)
     {
-        return new ChunkProviderStatic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+        return new ChunkProviderDynamic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
     }
 
     public static File getAppDir(String s)
@@ -1313,12 +1331,12 @@ public class Minecraft
         if(thePlayer != null)
         {
             IChunkProvider chunkProvider = theWorld.getChunkProvider();
-            if(chunkProvider instanceof ChunkProviderStatic)
+            if(chunkProvider instanceof ChunkProviderDynamic)
             {
-                ChunkProviderStatic chunkproviderloadorgenerate = (ChunkProviderStatic)chunkProvider;
+                ChunkProviderDynamic chunkProviderDynamic = (ChunkProviderDynamic)chunkProvider;
                 int playerChunkX = MathHelper.floor_float((int)thePlayer.x) >> 4;
                 int playerChunkZ = MathHelper.floor_float((int)thePlayer.z) >> 4;
-                chunkproviderloadorgenerate.setCurrentChunkOver(playerChunkX, playerChunkZ);
+                chunkProviderDynamic.setCurrentChunkOver(playerChunkX, playerChunkZ);
             }
         }
         if(!isGamePaused && theWorld != null)
@@ -2212,12 +2230,12 @@ public class Minecraft
             }
             playerController.adjustPlayer(thePlayer);
             IChunkProvider ichunkprovider = world.getChunkProvider();
-            if(ichunkprovider instanceof ChunkProviderStatic)
+            if(ichunkprovider instanceof ChunkProviderDynamic)
             {
-                ChunkProviderStatic chunkproviderloadorgenerate = (ChunkProviderStatic)ichunkprovider;
+                ChunkProviderDynamic chunkProviderDynamic = (ChunkProviderDynamic)ichunkprovider;
                 int i = MathHelper.floor_float((int)thePlayer.x) >> 4;
                 int j = MathHelper.floor_float((int)thePlayer.z) >> 4;
-                chunkproviderloadorgenerate.setCurrentChunkOver(i, j);
+                chunkProviderDynamic.setCurrentChunkOver(i, j);
             }
             world.spawnPlayerWithLoadedChunks(thePlayer);
             if(world.isNewWorld)
@@ -2303,9 +2321,9 @@ public class Minecraft
             chunkcoordinates.x = (int)thePlayer.x;
             chunkcoordinates.z = (int)thePlayer.z;
         }
-        if(ichunkprovider instanceof ChunkProviderStatic)
+        if(ichunkprovider instanceof ChunkProviderDynamic)
         {
-            ChunkProviderStatic chunkProvider = (ChunkProviderStatic)ichunkprovider;
+            ChunkProviderDynamic chunkProvider = (ChunkProviderDynamic)ichunkprovider;
             chunkProvider.setCurrentChunkOver(Math.floorDiv(chunkcoordinates.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(chunkcoordinates.z, Chunk.CHUNK_SIZE_Z));
         }
         for(int k = -c; k <= c; k += Chunk.CHUNK_SIZE_X)
@@ -2403,10 +2421,10 @@ public class Minecraft
             canRespawnAtBed = false;
         }
         IChunkProvider ichunkprovider = theWorld.getChunkProvider();
-        if(ichunkprovider instanceof ChunkProviderStatic)
+        if(ichunkprovider instanceof ChunkProviderDynamic)
         {
-            ChunkProviderStatic chunkproviderloadorgenerate = (ChunkProviderStatic)ichunkprovider;
-            chunkproviderloadorgenerate.setCurrentChunkOver(bedSpawnCoordinates.x >> 4, bedSpawnCoordinates.z >> 4);
+            ChunkProviderDynamic chunkProviderDynamic = (ChunkProviderDynamic)ichunkprovider;
+            chunkProviderDynamic.setCurrentChunkOver(bedSpawnCoordinates.x >> 4, bedSpawnCoordinates.z >> 4);
         }
         theWorld.getRespawnLocation();
         theWorld.updateEntityList();
diff --git a/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java b/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
index 76b30f83e..0f0b320b0 100644
--- a/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
+++ b/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
@@ -54,22 +54,21 @@ public class GuiControllerSetup extends GuiScreen {
 
         ControllerInput controller = mc.controllerInput;
 
-
         if (controller != null) {
-            boolean swapJoystickAndDPad = controller.getType().getCategory() == ControllerType.Category.XBOX || controller.getType().getCategory() == ControllerType.Category.NINTENDO;
+            boolean swapJoystickAndDPad = controller.getType().getLayout() == ControllerType.Layout.XBOX || controller.getType().getLayout() == ControllerType.Layout.NINTENDO;
             int y = height / 2 - 64;
 
+            int x1 = width / 2;
+
             glDisable(GL_DEPTH_TEST);
             glDisable(GL_CULL_FACE);
             glDisable(GL_TEXTURE_2D);
             if (swapJoystickAndDPad) {
-                drawJoystick(controller.joyLeft, width / 2 - 100 + 8, y + 32 + 4 + 8);
+                drawJoystick(controller.joyLeft, x1 - 100 + 8, y + 32 + 4 + 8);
             } else {
-                drawJoystick(controller.joyLeft, width / 2 - 48, y + 96);
+                drawJoystick(controller.joyLeft, x1 - 48, y + 96);
             }
-            drawJoystick(controller.joyRight, width / 2 - 48 + 64, y + 96);
-
-            int x1 = width / 2;
+            drawJoystick(controller.joyRight, x1 - 48 + 64, y + 96);
 
             GL11.glEnable(GL_TEXTURE_2D);
             fontRenderer.drawCenteredString("(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
@@ -91,7 +90,7 @@ public class GuiControllerSetup extends GuiScreen {
             if (swapJoystickAndDPad) {
                 glyphRenderer.drawDPad(controller, x1 - 48 - 8, y + 96 - 8, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
             } else {
-                glyphRenderer.drawDPad(controller, x1 - 48 - 8, y + 96 - 8, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
+                glyphRenderer.drawDPad(controller, x1 - 100, y + 32 + 4, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
             }
 
         }
@@ -106,27 +105,6 @@ public class GuiControllerSetup extends GuiScreen {
         glyphRenderer.drawButton(controller, controller.buttonY, x + w * 1, y + w * 0, controller.buttonY.isPressed());
     }
 
-    private void drawDPad(ControllerInput controller, int x, int y) {
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
-        glColor3d(1.0, 1.0, 1.0);
-        glBegin(GL_QUADS);
-
-        rectangle(x, y, 48, 48, 0, 64, 48, 48);
-
-        if (controller.digitalPad.up.isPressed())
-            rectangle(x + 18, y + 0, 12, 18, 66, 64, 12, 18);
-        if (controller.digitalPad.down.isPressed())
-            rectangle(x + 18, y + 30, 12, 18, 66, 94, 12, 18);
-        if (controller.digitalPad.left.isPressed())
-            rectangle(x + 0, y + 18, 18, 12, 48, 82, 18, 12);
-        if (controller.digitalPad.right.isPressed())
-            rectangle(x + 30, y + 18, 18, 12, 78, 82, 18, 12);
-
-        glEnd();
-
-    }
-
     @Override
     public void keyTyped(char c, int i, int mouseX, int mouseY) {
 
@@ -153,19 +131,6 @@ public class GuiControllerSetup extends GuiScreen {
         glVertex2d(x, y + h);
     }
 
-    private void rectangle(double x, double y, double w, double h, int u0, int v0, int uw, int vh) {
-        double u1 = u0 + uw;
-        double v1 = v0 + vh;
-        glTexCoord2d(u0 / 256.0, v0 / 256.0);
-        glVertex2d(x, y);
-        glTexCoord2d(u1 / 256.0, v0 / 256.0);
-        glVertex2d(x + w, y);
-        glTexCoord2d(u1 / 256.0, v1 / 256.0);
-        glVertex2d(x + w, y + h);
-        glTexCoord2d(u0 / 256.0, v1 / 256.0);
-        glVertex2d(x, y + h);
-    }
-
     @Override
     protected void buttonPressed(GuiButton button) {
         super.buttonPressed(button);
@@ -173,17 +138,17 @@ public class GuiControllerSetup extends GuiScreen {
         if (button.id == 0) {
             int index;
             if (mc.controllerInput == null) {
-                index = 0;
+                index = -1;
             } else {
                 index = Arrays.asList(InputHandler.controllers).indexOf(mc.controllerInput);
-                do {
-                    index++;
-                    if (index >= InputHandler.controllers.length) {
-                        index = -1;
-                        break;
-                    }
-                } while (InputHandler.controllers[index] == null);
             }
+            do {
+                index++;
+                if (index >= InputHandler.controllers.length) {
+                    index = -1;
+                    break;
+                }
+            } while (InputHandler.controllers[index] == null);
             if (index == -1) {
                 mc.controllerInput = null;
                 mc.setInputType(InputType.KEYBOARD);
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngame.java b/src/main/java/net/minecraft/client/gui/GuiIngame.java
index c4f7123b2..35a761ce0 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngame.java
+++ b/src/main/java/net/minecraft/client/gui/GuiIngame.java
@@ -20,6 +20,9 @@ import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.terrain.RenderList;
+import net.minecraft.client.render.terrain.RenderRegion;
+import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -206,7 +209,48 @@ public class GuiIngame extends Gui
                 
                 drawDebugScreenLine("Better than Adventure! " + Minecraft.VERSION);
                 drawDebugScreenLine(mc.debug);
-                drawDebugScreenLine(mc.getRendererDebugInfo());
+                if(mc.terrainRenderer instanceof TerrainRendererMultiDraw) {
+                	TerrainRendererMultiDraw terrainRenderer = (TerrainRendererMultiDraw) mc.terrainRenderer;
+                	
+                	int regionCount = terrainRenderer.regionBuffer.size();
+
+                    int playerX = MathHelper.floor(mc.thePlayer.x);
+                    int playerZ = MathHelper.floor(mc.thePlayer.z);
+
+                	
+                	List<RenderRegion> allRegions = terrainRenderer.regionBuffer.getAllRegions();
+                    int totalEntries = 0;
+                    int visibleEntries = 0;
+                	for(int i=0; i < allRegions.size(); i++) {
+                        RenderRegion region = allRegions.get(i);
+                        for(int j=0; j < region.renderLists.length; j++) {
+                        	RenderList renderList = region.renderLists[j];
+                        	if(renderList == null) {
+                        		continue;
+                        	}
+                        	totalEntries += renderList.size();
+                        	visibleEntries += renderList.visibleEntryCount();
+                        }
+                	}
+                	
+                	drawDebugScreenLine("R: " + regionCount + " D: " + terrainRenderer.getTotalDrawCalls() + " T: " + visibleEntries + "/" + totalEntries + " VBO: " + terrainRenderer.vertexBuffer.entryCount());
+                	
+                	RenderRegion currentRegion = terrainRenderer.getRenderRegionAtBlockPos(playerX, playerZ);
+                    totalEntries = 0;
+                    visibleEntries = 0;
+                    for(int j=0; j < currentRegion.renderLists.length; j++) {
+                    	RenderList renderList = currentRegion.renderLists[j];
+                    	if(renderList == null) {
+                    		continue;
+                    	}
+                    	totalEntries += renderList.size();
+                    	visibleEntries += renderList.visibleEntryCount();
+                    }
+                	drawDebugScreenLine("CR: " + currentRegion + " E: " + visibleEntries + "/" + totalEntries);
+
+                }else {
+                    drawDebugScreenLine(mc.getRendererDebugInfo());
+                }
                 drawDebugScreenLine(mc.getEntityDebugInfoString());
                 drawDebugScreenLine(mc.getEntityCountsInfoString());
                 drawDebugScreenLine(mc.getChunkProviderInfoString());
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 246088f51..efa2030db 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -258,6 +258,7 @@ public abstract class OptionsPages
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyReloadChunks))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keySmoothLighting))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyReleaseCursor))
+            .withComponent(new KeyBindingComponent(mc.gameSettings.keyLoadChunksQuickly))
         )
         .withComponent(new OptionsCategory("gui.options.page.debug.category.settings")
             .withComponent(new BooleanOptionComponent(mc.gameSettings.alphaMenu))
@@ -267,7 +268,6 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.showChunkBorders))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.showCollisionBoxes))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.showItemDebugInfo))
-            .withComponent(new BooleanOptionComponent(mc.gameSettings.disableJInput))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.disableCrashHandler))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.startInFullscreen))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.disableShaders))
@@ -275,6 +275,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.allowSoundOverrides))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.downloadSoundfiles))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
+            .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
         )
         .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
diff --git a/src/main/java/net/minecraft/client/input/InputHandler.java b/src/main/java/net/minecraft/client/input/InputHandler.java
index 473e3a096..b8f1c3ad2 100644
--- a/src/main/java/net/minecraft/client/input/InputHandler.java
+++ b/src/main/java/net/minecraft/client/input/InputHandler.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.input;
 
+import net.minecraft.client.input.glfw.FakeGamepad;
 import org.lwjgl.glfw.GLFW;
 
 import net.minecraft.client.Minecraft;
@@ -13,21 +14,11 @@ public abstract class InputHandler {
 	
 	public static void init(Minecraft minecraft) throws Exception{
 		InputHandler.minecraft = minecraft;
-		
-        if(!minecraft.gameSettings.disableJInput.value) {
-        	try {
-        		initJInput(minecraft);
-        	}catch (Throwable e) {
-        		System.err.println("Could not initialize JInput.");
-        		e.printStackTrace();
-			}
-        }else {
-        	System.err.println("JInput is disabled!");
-        }
+
 		try {
 			initLWJGL3(minecraft);
 		} catch (Throwable e) {
-			System.err.println("Could not initialize SDL2.");
+			System.err.println("Could not initialize LWJGL3.");
 			e.printStackTrace();
 		}
 	}
@@ -79,30 +70,15 @@ public abstract class InputHandler {
 				}
 			}
 		}
+//		int[] vids = { 0x0079, 0x0079, 0x054c, 0x0079, 0x03F0, 0x057e, 0x28de, 0x28de };
+//		int[] pids = { 0x181a, 0x181b, 0x0ce6, 0x18d4, 0x0495, 0x2008, 0x1101, 0x11ff };
+//		String[] names = { "Fake PS3", "Fake PS4", "Fake PS5", "Fake X360", "Fake XONE", "Fake Switch", "Fake Steam", "Fake Steam Deck" };
+//		for (int i = 0; i < vids.length; i++) {
+//			controllers[GLFW.GLFW_JOYSTICK_1 + i] = new ControllerInput(minecraft, new FakeGamepad(GLFW.GLFW_JOYSTICK_1 + i, names[i], vids[i], pids[i]));
+//		}
 		System.out.println(found + " controllers found!");
 	}
 	
-	public static void initJInput(Minecraft minecraft) throws Throwable{
-		net.java.games.input.Controller[] devices = getControllers();
-		
-		if(devices == null) {
-			System.err.println("Could not get devices!");
-			return;
-		}
-		
-		System.out.println(devices.length + " devices found!");
-		
-		for(net.java.games.input.Controller controller : devices) {
-			if(controller.getType() == net.java.games.input.Controller.Type.MOUSE) {
-				minecraft.mouseInput.addMouse(controller);
-			}
-		}
-	}
-	
-	public static net.java.games.input.Controller[] getControllers() throws Throwable{
-		return net.java.games.input.ControllerEnvironment.getDefaultEnvironment().getControllers();
-	}
-	
 	public static ControllerInput getController(String guid) {
 		try {
 			for(ControllerInput controllerInput : controllers) {
@@ -113,13 +89,5 @@ public abstract class InputHandler {
 		}catch (Exception e) {}
 		return null;
 	}
-	
-	public static net.java.games.input.Component getComponent(net.java.games.input.Controller controller, String id) {
-		try {
-			for(net.java.games.input.Component component : controller.getComponents()) {
-				if(component.getIdentifier().toString().equalsIgnoreCase(id)) return component;
-			}
-		}catch (Exception e) {}
-		return null;
-	}
+
 }
diff --git a/src/main/java/net/minecraft/client/input/MouseInput.java b/src/main/java/net/minecraft/client/input/MouseInput.java
index 0e5346ddf..5a25e5b8a 100644
--- a/src/main/java/net/minecraft/client/input/MouseInput.java
+++ b/src/main/java/net/minecraft/client/input/MouseInput.java
@@ -3,18 +3,16 @@ package net.minecraft.client.input;
 import java.util.ArrayList;
 import java.util.List;
 
+import net.minecraft.client.render.window.GameWindowGLFW;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Mouse;
 
-import net.java.games.input.Component;
-import net.java.games.input.Controller;
 import net.minecraft.client.Minecraft;
 
 public class MouseInput {
 	
 	public final Minecraft minecraft;
-	
-	private List<MouseDevice> mouses;
-	
+
 	public double deltaX;
 	public double deltaY;
 	
@@ -33,45 +31,14 @@ public class MouseInput {
 	}
 	
 	public void update() {
-		if(minecraft.gameSettings.rawMouseInput.value && this.mouses != null && this.mouses.size() > 0) {
-			this.deltaX = 0.0;
-			this.deltaY = 0.0;
-			
-			for(int i=0; i < mouses.size(); i++) {
-				MouseDevice mouse = mouses.get(i);
-				
-				mouse.device.poll();
-				
-				this.deltaX += mouse.x.getPollData() * 0.5;
-				this.deltaY += mouse.y.getPollData() * -0.5;
-			}
-		}else {
-			this.deltaX = Mouse.getDX();
-			this.deltaY = Mouse.getDY();
-		}
+		this.deltaX = Mouse.getDX();
+		this.deltaY = Mouse.getDY();
 	}
-	
-	public void addMouse(Controller controller) {
-		if(this.mouses == null) {
-			this.mouses = new ArrayList<>();
-		}
-		this.mouses.add(new MouseDevice(controller));
-	}
-	
-	public static class MouseDevice{
-		
-		private Controller device;
-		
-		private Component x;
-		private Component y;
-		
-		public MouseDevice(Controller device) {
-			this.device = device;
-			
-			this.x = InputHandler.getComponent(device, "x");
-			this.y = InputHandler.getComponent(device, "y");
+
+	public void setRawInput(boolean enabled) {
+		if (GLFW.glfwRawMouseMotionSupported()) {
+			GLFW.glfwSetInputMode(((GameWindowGLFW) minecraft.gameWindow).window, GLFW.GLFW_RAW_MOUSE_MOTION, enabled ? 1 : 0);
 		}
-		
 	}
 	
 }
